void Zeichen0(float zeicheniteration, float distanz, PVector abstandmaus, boolean rotation, boolean position, boolean skalierung, boolean mode, float interactiviti)
{
  pushStyle();
  noStroke();
  fill(schwarz);
  ellipseMode(CENTER);
  pushMatrix();
  if (mode)
  {
    if (rotation)
    {
      rotate(distanz*interactiviti/50);
    }
    if (position)
    {
      translate(abstandmaus.x/distanz/interactiviti/50, abstandmaus.y/distanz/interactiviti/50);
    }
    if (skalierung)
    {
      scale(distanz*interactiviti/50, distanz*interactiviti/50);
    }
  }
  else
  {
    if (rotation)
    {
      rotate(distanz*interactiviti/50*(-1));
    }
    if (position)
    {
      translate((-1)*abstandmaus.x/distanz/interactiviti, (-1)*abstandmaus.y/distanz/interactiviti);
    }
    if (skalierung)
    {
      scale((1/(distanz-0.1))*interactiviti/500, (1/(distanz-0.1))*interactiviti/500);
    }
  }
  ellipse(0, 0, (7-zeicheniteration)*zeichendurchmesser/5, (7-zeicheniteration)*zeichendurchmesser/5);
  popMatrix();
  popStyle();
}

void Zeichen1(float zeicheniteration, float distanz, PVector abstandmaus, boolean rotation, boolean position, boolean skalierung, boolean mode, float interactiviti)
{
  pushStyle();
  noStroke();
  pushMatrix();
  if (mode)
  {
    if (rotation)
    {
      rotate(distanz*interactiviti/50);
    }
    if (position)
    {
      translate(abstandmaus.x/distanz/interactiviti, abstandmaus.y/distanz/interactiviti);
    }
    if (skalierung)
    {
      scale(distanz*interactiviti/50, distanz*interactiviti/50);
    }
  }
  else
  {
    if (rotation)
    {
      rotate(distanz*interactiviti/50*(-1));
    }
    if (position)
    {
      translate((-1)*abstandmaus.x/distanz/interactiviti, (-1)*abstandmaus.y/distanz/interactiviti);
    }
    if (skalierung)
    {
      scale((1/(distanz-0.1))*interactiviti/500, (1/(distanz-0.1))*interactiviti/500);
    }
  }
  boolean z = true;
  for (int i = 0; i < 6; i = i+1)
  {
    pushMatrix();
    rotate(((-i))*(radians(6.42857)*(6*zeicheniteration*distanz)));
    scale(pow(pow( (0.9), i), 1/4+1.62), pow(pow( (0.9), i), 1/4+1.62));
    if (z) { 
      fill(schwarz);
    } 
    else { 
      fill(weiss);
    }
    rectMode(CENTER);
    rect(0, 0, zeichendurchmesser, zeichendurchmesser);
    popMatrix();
    z=!z;
  }
  popMatrix();
  popStyle();
}

void Zeichen2(float zeicheniteration, float distanz, PVector abstandmaus, boolean rotation, boolean position, boolean skalierung, boolean mode, float interactiviti)
{
  pushStyle();
  noStroke();
  pushMatrix();
  if (mode)
  {
    if (rotation)
    {
      rotate(distanz*interactiviti/50);
    }
    if (position)
    {
      translate(abstandmaus.x/distanz/interactiviti, abstandmaus.y/distanz/interactiviti);
    }
    if (skalierung)
    {
      scale(distanz*interactiviti/50, distanz*interactiviti/50);
    }
  }
  else
  {
    if (rotation)
    {
      rotate(distanz*interactiviti/50*(-1));
    }
    if (position)
    {
      translate((-1)*abstandmaus.x/distanz/interactiviti, (-1)*abstandmaus.y/distanz/interactiviti);
    }
    if (skalierung)
    {
      scale((1/(distanz-0.1))*interactiviti/500, (1/(distanz-0.1))*interactiviti/500);
    }
  }
  boolean z = true;
  for (int i = 0; i < 6; i = i+1)
  {
    pushMatrix();
    rotate(((-i))*(radians(6.42857)*(zeicheniteration*distanz)));
    scale(pow(pow( (0.9), i), 1/4+1.62), pow(pow( (0.9), i), 1/4+1.62));
    if (z) { 
      fill(schwarz);
    } 
    else { 
      fill(weiss);
    }
    rectMode(CENTER);
    rect(0, 0, zeichendurchmesser, zeichendurchmesser);
    popMatrix();
    z=!z;
  }
  popMatrix();
  popStyle();
}

void Zeichen3(float zeicheniteration, float distanz, PVector abstandmaus, boolean rotation, boolean position, boolean skalierung, boolean mode, float interactiviti)
{
  pushStyle();
  pushMatrix();
  if (mode)
  {
    if (rotation)
    {
      rotate(distanz*interactiviti/50);
    }
    if (position)
    {
      translate(abstandmaus.x/distanz/interactiviti, abstandmaus.y/distanz/interactiviti);
    }
    if (skalierung)
    {
      scale(distanz*interactiviti/50, distanz*interactiviti/50);
    }
  }
  else
  {
    if (rotation)
    {
      rotate(distanz*interactiviti/50*(-1));
    }
    if (position)
    {
      translate((-1)*abstandmaus.x/distanz/interactiviti, (-1)*abstandmaus.y/distanz/interactiviti);
    }
    if (skalierung)
    {
      scale((1/(distanz-0.1))*interactiviti/500, (1/(distanz-0.1))*interactiviti/500);
    }
  }
  boolean z = true;
  for (int i = 0; i < 40; i = i+1)
  {
    pushMatrix();
    rotate(((-i))*(radians(6.42857)*(zeicheniteration*distanz)));
    scale(pow(pow( (0.95), i), 1/4+1.62), pow(pow( (0.95), i), 1/4+1.62));
    if (z) { 
      fill(schwarz);
    } 
    else { 
      fill(weiss);
    }
    rectMode(CENTER);
    rect(0, 0, zeichendurchmesser, zeichendurchmesser);
    popMatrix();
    z=!z;
  }
  popMatrix(); 
  popStyle();
}
void Zeichen4(float zeicheniteration, float distanz, PVector abstandmaus, boolean rotation, boolean position, boolean skalierung, boolean mode, float interactiviti)
{
  pushStyle();
  pushMatrix();
  if (mode)
  {
    if (rotation)
    {
      rotate(distanz*interactiviti/50);
    }
    if (position)
    {
      translate(abstandmaus.x/distanz/interactiviti, abstandmaus.y/distanz/interactiviti);
    }
    if (skalierung)
    {
      scale(distanz*interactiviti/50, distanz*interactiviti/50);
    }
  }
  else
  {
    if (rotation)
    {
      rotate(distanz*interactiviti/50*(-1));
    }
    if (position)
    {
      translate((-1)*abstandmaus.x/distanz/interactiviti, (-1)*abstandmaus.y/distanz/interactiviti);
    }
    if (skalierung)
    {
      scale((1/(distanz-0.1))*interactiviti/500, (1/(distanz-0.1))*interactiviti/500);
    }
  }
  int s = 100; //durcmesser kreis weiss
  int v = 45; // verschiebung kreise  weiss-weiss X
  int w = 75; // verschiebung kreise  weiss-weiss Y
  float t = 0;
  float f = 0.9;
  float p = 5;
  float c=1;
//  c = map(abstandmaus.y*abstandmaus.x, 0, (raster*(zeichenabstand+zeichendurchmesser)+zeichenabstand)*(raster*(zeichenabstand+zeichendurchmesser)+zeichenabstand), 0, 7);
c= zeicheniteration+ distanz*interactiviti/5;
  if (c>7)
  {
    c=(7-(c-7));
  }
  if (c<1)
  {
    c=((-1)*(c-1))+1;
  }
  p = p+(2.5)*c;
  f = pow(f, c);
  t = t + (3.8)*c;
  ;
  pushMatrix();
  translate(0, 0);
  scale(0.4, 0.4);
  fill(schwarz);
  ellipse(0, 50, 200, 200);
  fill(weiss);
  pushMatrix();
  translate(0, t);
  Kreis(t, p, f, s);
  popMatrix();
  pushMatrix();
  translate(v*f, w*f+t);
  rotate(radians(120));
  Kreis(t, p, f, s);
  popMatrix();
  pushMatrix();
  translate(-v*f, w*f+t);
  rotate(radians(-120));
  Kreis(t, p, f, s);
  popMatrix();
  popMatrix();
  popMatrix();
  popStyle();
} 

void Zeichen5(float zeicheniteration, float distanz, PVector abstandmaus, boolean rotation, boolean position, boolean skalierung, boolean mode, float interactiviti)
{
  pushStyle();
  pushMatrix();
  
  if (mode)
  {
    if (rotation)
    {
      rotate(distanz*interactiviti/50);
    }
    if (position)
    {
      translate(abstandmaus.x/distanz/interactiviti, abstandmaus.y/distanz/interactiviti);
    }
    if (skalierung)
    {
      scale(distanz*interactiviti/50, distanz*interactiviti/50);
    }
  }
  else
  {
    if (rotation)
    {
      rotate(distanz*interactiviti/50*(-1));
    }
    if (position)
    {
      translate((-1)*abstandmaus.x/distanz/interactiviti, (-1)*abstandmaus.y/distanz/interactiviti);
    }
    if (skalierung)
    {
      scale((1/(distanz-0.01))*interactiviti/100, (1/(distanz-0.01))*interactiviti/100);
    }
  }
  rectMode(CENTER);
  rect(0, 0, zeichendurchmesser, zeichendurchmesser);
  popMatrix(); 
  popStyle();
}

void Kreis(float t, float p, float f, float s)
{
  pushMatrix();
  rotate(radians(-90));
  stroke(weiss);
  strokeWeight(3);
  noFill();
  for (int i = 0; i < p;i=i+1)
  {
    ellipse(0-i/2, 0, (s-i), (s-i));
    ellipse(0+i/2, 0, (s+i), (s+i));
  }
  popMatrix();
}

